Index: src/io.c
--- src/io.c.orig	2005-06-01 00:30:14 +0200
+++ src/io.c	2005-06-13 20:27:59 +0200
@@ -46,6 +46,10 @@
 #include "string.h"		/* extended string functions */
 #include "message.h"		/* information, warning and error messages */
 
+#ifndef O_LARGEFILE
+#define O_LARGEFILE 0
+#endif
+
 #ifdef NEXT
   #include <sys/uio.h>
 #endif
@@ -133,7 +137,7 @@
   off_t
     fsize,		/* original file size */
     wtotal;		/* total read bytes */
-  blksize_t
+  size_t
     blksize;		/* file system block size */
 
   wtotal=0;
Index: src/io.h
--- src/io.h.orig	2002-08-04 17:11:33 +0200
+++ src/io.h	2005-06-13 20:23:00 +0200
@@ -15,6 +15,8 @@
  * This file is covered by the GNU General Public License
  */
 
+#include <sys/types.h>
+
 
 /* read n bytes from network socket */
 int readn(int, char *, int);
Index: src/sendfiled.c
--- src/sendfiled.c.orig	2005-06-01 11:04:40 +0200
+++ src/sendfiled.c	2005-06-13 20:27:35 +0200
@@ -194,6 +194,10 @@
 #include "address.h"	/* address routines */
 #include "lock.h"       /* file locking */
 
+#ifndef O_LARGEFILE
+#define O_LARGEFILE 0
+#endif
+
 #if defined(HAVE_GETOPT_H)
   #include <getopt.h>
 #else
@@ -4042,11 +4046,13 @@
  * RETURN: nothing, but terminates program on error
  */
 void setreugid() {
+  if (rgid != getegid())
   if (rgid && setegid(rgid)<0) {
     printf("490 Internal error on setegid(%u): %s\r\n",
 	   (unsigned int)rgid,strerror(errno));
     exit(1);
   }
+  if (ruid != geteuid())
   if (ruid && seteuid(ruid)<0) {
     printf("490 Internal error on seteuid(%u): %s\r\n",
 	   (unsigned int)ruid,strerror(errno));
Index: src/spool.c
--- src/spool.c.orig	2005-05-31 17:46:57 +0200
+++ src/spool.c	2005-06-13 20:28:17 +0200
@@ -64,6 +64,10 @@
 #include "string.h"     /* extended string functions */
 #include "reply.h"	/* the 3 digit reply codes with text messages */
 
+#ifndef O_LARGEFILE
+#define O_LARGEFILE 0
+#endif
+
 
 /*
  * scanspool - scan through spool directory, build list-structures and
